/*************************************************************************************
	NOTEMIDISCALE - plays a 5-note test scale to a MIDI device

	(C) 2001 by Michael Minn - michael@michaelminn.com

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

*************************************************************************************/

#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>

int main (int argc, char **argv)
{
	printf("NOTEMIDISCALE v2001.06.05 by Michael Minn\n");

	if (argc != 2)
	{
		printf("SYNTAX: notemidiscale <midi device name>\n");
		printf("    plays a 5-note test scale to a MIDI device\n");
		return -1;
	}

	int status = 0;
	int device = open(argv[1], O_WRONLY | O_SYNC);
	char note_on[15] = {0x90, 0x37, 0x70, 0x90, 0x35, 0x70, 0x90, 0x34, 0x70, 0x90, 0x32, 0x70, 0x90, 0x30, 0x70 };
	char note_off[15] = {0x80, 0x37, 0x70, 0x80, 0x35, 0x70, 0x80, 0x34, 0x70, 0x80, 0x32, 0x70, 0x80, 0x30, 0x70 };

	if (device < 0)
		perror(argv[1]);

	else for (int scan = 0; scan < 5; ++scan)
		if (write(device, &note_on[scan * 3], 3) < 0)
			perror(argv[1]);

		else if (sleep(1) < 0)
			perror("sleep failure");

		else if (write(device, &note_off[scan * 3], 3) < 0)
			perror(argv[1]);
}


